# -*- coding: utf-8 -*-
from setuphelpers import *

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
bin_name = "charlemagne_moteur.exe"
silent_args = "/S"
desktop_shortcut_names = []
path_folder = makepath(programfiles32(),'alcuin')
all_path_bin_exe = [ # Edit here the name of the executable
    makepath(path_folder, 'Donnees.exe'), 
    makepath(path_folder, 'WDModFic.exe'), 
    makepath(path_folder, 'WDOptimiseur.exe')
]

def install():
    
    # Initializing variables
    package_version = control.version.split("-")[0]

    # Installing the package
    print(f"Installing: {bin_name}")
    file_version = makepath(path_folder,'wMoteur%s.txt' % package_version.replace('.','_'))
    
    if force or not isfile(file_version):
        run(f"{makepath(basedir, bin_name)} {silent_args}")
    
    if not isfile(file_version):
        error('Error %s not found' % file_version)
        
    # Allow user to delete shortcut / or remove the shortcut
    for desktop_shortcut_name in desktop_shortcut_names:
        file_path = rf"{makepath(common_desktop(), desktop_shortcut_name)}.lnk"
        # run_powershell(rf"icacls '{file_path}' /grant '*S-1-5-32-545:(RX,DE)'") # BUILTIN\Utilisateurs
        remove_file(file_path)

def audit():
    
    for path_bin_exe in all_path_bin_exe:
        if not isfile(path_bin_exe):
            print(f"The executable can't be found here : {path_bin_exe}")
            return "ERROR"

    # Initializing variables
    package_version = control.version.split("-")[0]

    file_version = makepath(path_folder,'wMoteur%s.txt' % package_version.replace('.','_'))     
    if not isfile(file_version):
        print('%s not found, Was the version updated ?' % file_version)
        return "WARNING"
    
    print("The installation has been done correctly")
    return "OK"